//------------------------------------------------------------------
// Random walk index developed by Micheal Poulos
// source : TASC 10:9 (385-389): Are There Persistent Cycles?
//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers 4
#property indicator_color1  Green
#property indicator_color2  Red
#property indicator_color3  DarkGray
#property indicator_style3  STYLE_DOT
#property indicator_width1  2
#property indicator_width2  2
#property indicator_minimum 0

#import "random walk index.dll"
   void iRWI(double &rates[][6],int length, double& results[],int totalBars,int shift);
#import

//
//
//
//
//

extern int RWILength = 25;

double RWIUp[];
double RWIDown[];
double Zline[];
double rates[][6];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   SetIndexBuffer(0,RWIUp);
   SetIndexBuffer(1,RWIDown);
   SetIndexBuffer(2,Zline);
           ArrayCopyRates(rates,NULL,0);
   IndicatorShortName("Random walk index ("+RWILength+")");
   return(0);
}
int deinit()
{
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double results[2];
#define _rwiUp 0
#define _rwiDo 1

int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars < 0) return(-1);
      if(counted_bars > 0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
         int totalRates = ArrayRange(rates,0);

   //
   //
   //
   //
   //

   for (int i=limit; i>=0; i--)
   {  
      iRWI(rates,RWILength,results,totalRates,i);
         RWIUp[i]   = results[_rwiUp];
         RWIDown[i] = results[_rwiDo];
         Zline[i]   = 1.00;
   }         
   return(0);
}